#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <sdkhooks>
#include <smartdm>
#include <shop>

#undef REQUIRE_PLUGIN
#include <zombiereloaded>
#include <zriot>
#include <ToggleEffects>

#define PLUGIN_VERSION	"2.0.1"
#define CATEGORY	"trails"

new bool:toggleEffects = false;
new bool:hide = false;

new Handle:hKvTrails;

new iTeam[MAXPLAYERS+1];
new g_SpriteModel[MAXPLAYERS + 1] = {-1, ...};
new selected_id[MAXPLAYERS+1] = {-1, ...};

public Plugin:myinfo =
{
	name = "[Shop] Trails",
	author = "FrozDark (HLModders LLC)",
	description = "Trails that folows a player",
	version = PLUGIN_VERSION,
	url = "http://www.hlmod.ru/"
};

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	MarkNativeAsOptional("ZR_IsClientHuman"); 
	MarkNativeAsOptional("ZR_IsClientZombie"); 
	MarkNativeAsOptional("ZRiot_IsClientHuman"); 
	MarkNativeAsOptional("ZRiot_IsClientZombie"); 

	return APLRes_Success;
}

public OnPluginStart()
{
	HookEvent("player_spawn", PlayerSpawn);
	HookEvent("player_death", PlayerDeath);
	HookEvent("player_team", PlayerTeam);
	
	for (new i = 1; i <= MaxClients; i++)
	{
		if (IsClientInGame(i))
		{
			iTeam[i] = GetClientTeam(i);
		}
	}
	
	RegAdminCmd("sm_trails_reload", Command_TrailsReload, ADMFLAG_ROOT, "Reloads trails config list");
	
	if (Shop_IsConnected()) Shop_OnConnected();
}

public OnAllPluginsLoaded()
{
	toggleEffects = LibraryExists("specialfx");
}

public OnLibraryAdded(const String:name[])
{
	if (StrEqual(name, "specialfx"))
	{
		toggleEffects = true;
	}
}

public OnLibraryRemoved(const String:name[])
{
	if (StrEqual(name, "specialfx"))
	{
		toggleEffects = false;
	}
}

public Shop_OnConnected()
{
	if (hKvTrails == INVALID_HANDLE) OnMapStart();
	
	KvRewind(hKvTrails);
	decl String:name[64], String:description[64];
	KvGetString(hKvTrails, "name", name, sizeof(name), "Trails");
	KvGetString(hKvTrails, "description", description, sizeof(description));
	
	Shop_RegisterCategory(CATEGORY, name, description, OnCategoryRegistered);
}

public OnCategoryRegistered(const String:category[], const String:name[], const String:description[])
{
	decl String:item[64], String:item_name[64], String:item_description[64], String:buffer[PLATFORM_MAX_PATH];
	KvRewind(hKvTrails);
	if (KvGotoFirstSubKey(hKvTrails))
	{
		do
		{
			KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
			if (!File_ExtEqual(buffer, "vmt")) continue;
			
			KvGetSectionName(hKvTrails, item, sizeof(item));
			
			if (Shop_StartItem(CATEGORY, item))
			{
				KvGetString(hKvTrails, "name", item_name, sizeof(item_name), item);
				KvGetString(hKvTrails, "description", item_description, sizeof(item_description));
				Shop_SetItemInfo(item_name, item_description, KvGetNum(hKvTrails, "price", 500), KvGetNum(hKvTrails, "sell_price", -1), Item_Togglable, KvGetNum(hKvTrails, "duration", 604800));
				Shop_SetItemCallbacks(OnEquipItem, OnItemRegistered);
				Shop_SetItemCustomInfo("level", KvGetNum(hKvTrails, "level", 0));
				Shop_EndItem();
				
				Downloader_AddFileToDownloadsTable(buffer);
				PrecacheModel(buffer);
			}
		}
		while (KvGotoNextKey(hKvTrails));
	}
	
	KvRewind(hKvTrails);
}

public OnItemRegistered(const String:category[], const String:item[], itemID)
{
	KvRewind(hKvTrails);
	if (KvJumpToKey(hKvTrails, item))
	{
		KvSetNum(hKvTrails, "id", itemID);
	}
	KvRewind(hKvTrails);
}

public Action:Command_TrailsReload(client, args)
{
	if (hKvTrails != INVALID_HANDLE)
	{
		CloseHandle(hKvTrails);
		hKvTrails = INVALID_HANDLE;
	}
	OnMapStart();
	
	KvRewind(hKvTrails);
	decl String:item[64], String:item_name[64], String:item_description[64], String:buffer[PLATFORM_MAX_PATH];
	if (KvGotoFirstSubKey(hKvTrails))
	{
		do
		{
			KvGetSectionName(hKvTrails, item, sizeof(item));
			new id = Shop_GetItemId(CATEGORY, item);
			if (id != -1)
			{
				KvSetNum(hKvTrails, "id", id);
			}
			else
			{
				KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
				if (!File_ExtEqual(buffer, "vmt")) continue;
				
				if (Shop_StartItem(CATEGORY, item))
				{
					KvGetString(hKvTrails, "name", item_name, sizeof(item_name), item);
					KvGetString(hKvTrails, "description", item_description, sizeof(item_description));
					Shop_SetItemInfo(item_name, item_description, KvGetNum(hKvTrails, "price", 500), KvGetNum(hKvTrails, "sell_price", -1), Item_Togglable, KvGetNum(hKvTrails, "duration", 604800));
					Shop_SetItemCallbacks(OnEquipItem, OnItemRegistered);
					Shop_EndItem();
					
					Downloader_AddFileToDownloadsTable(buffer);
					PrecacheModel(buffer);
				}
			}
		}
		while (KvGotoNextKey(hKvTrails));
	}
	KvRewind(hKvTrails);
	
	ReplyToCommand(client, "Trails config list reloaded successfully!");
	
	return Plugin_Handled;
}

public OnMapStart()
{
	if (hKvTrails != INVALID_HANDLE)
	{
		decl String:buffer[PLATFORM_MAX_PATH];
		if (KvGotoFirstSubKey(hKvTrails))
		{
			do
			{
				if (KvGetNum(hKvTrails, "id") == 0) continue;
				
				KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
				
				Downloader_AddFileToDownloadsTable(buffer);
				PrecacheModel(buffer, true);
			}
			while (KvGotoNextKey(hKvTrails));
		}
		return;
	}
	
	hKvTrails = CreateKeyValues("Trails");
	
	decl String:_buffer[PLATFORM_MAX_PATH];
	Shop_GetCfgFile(_buffer, sizeof(_buffer), "trails.txt");
	
	if (!FileToKeyValues(hKvTrails, _buffer)) SetFailState("\"%s\" not found", _buffer);
	
	KvRewind(hKvTrails);
	
	hide = bool:KvGetNum(hKvTrails, "hide_opposite_team", 1);
}

public OnPluginEnd()
{
	Shop_UnregisterMe();
	for (new i = 1; i <= MaxClients; i++)
	{
		KillTrail(i);
	}
}

public ShopAction:OnEquipItem(client, const String:category[], const String:item[], itemID, bool:toggledOn)
{
	if (toggledOn)
	{
		OnClientDisconnect(client);
		
		selected_id[client] = -1;
		
		return Shop_ToggleOff;
	}
	
	Shop_ToggleCategoryOff(client, category);
	
	selected_id[client] = itemID;
	
	SpriteTrail(client);
	
	return Shop_ToggleOn;
}

public OnMapEnd()
{
	for (new client = 1; client <= MAXPLAYERS; client++)
	{
		g_SpriteModel[client] = -1;
	}
}

public OnClientDisconnect(client)
{
	KillTrail(client);
}

public OnClientDisconnect_Post(client)
{
	iTeam[client] = 0;
	selected_id[client] = -1;
	g_SpriteModel[client] = -1;
}

public PlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast)
{
	CreateTimer(1.0, GiveTrail, GetEventInt(event, "userid"));
}

public PlayerTeam(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));
	iTeam[client] = GetEventInt(event, "team");
}

public PlayerDeath(Handle:event,const String:name[],bool:dontBroadcast)
{
	new client = GetClientOfUserId(GetEventInt(event, "userid"));

	KillTrail(client);
}

public Action:GiveTrail(Handle:timer, any:userid)
{
	SpriteTrail(GetClientOfUserId(userid));
}

public ZRiot_OnClientHuman(client)
{
	SpriteTrail(client);
}

public ZR_OnClientHumanPost(client, bool:respawn, bool:protect)
{
	SpriteTrail(client);
}

public ZR_OnClientInfected(client, attacker, bool:motherInfect, bool:respawnOverride, bool:respawn)
{
	SpriteTrail(client);
}

public ZRiot_OnClientZombie(client)
{
	SpriteTrail(client);
}

bool:SpriteTrail(client)
{
	if (!client)
	{
		return false;
	}

	KillTrail(client);
	
	if (selected_id[client] == -1 || iTeam[client] == 0 || IsFakeClient(client))
	{
		return false;
	}
	if (!IsPlayerAlive(client) || !(1 < iTeam[client] < 4))
	{
		return true;
	}
	
	new id;
	if (KvGotoFirstSubKey(hKvTrails))
	{
		do
		{
			if (KvGetNum(hKvTrails, "id") != selected_id[client]) continue;
			
			id = selected_id[client];
			
			break;
		}
		while (KvGotoNextKey(hKvTrails));
	}
	if (!id)
	{
		KvRewind(hKvTrails);
		return false;
	}
	
	g_SpriteModel[client] = CreateEntityByName("env_spritetrail");
	if (g_SpriteModel[client] != -1) 
	{
		decl String:buffer[PLATFORM_MAX_PATH], Float:dest_vector[3];
		
		DispatchKeyValueFloat(g_SpriteModel[client], "lifetime", KvGetFloat(hKvTrails, "lifetime", 1.0));
		
		KvGetString(hKvTrails, "startwidth", buffer, sizeof(buffer), "10");
		DispatchKeyValue(g_SpriteModel[client], "startwidth", buffer);
		KvGetString(hKvTrails, "endwidth", buffer, sizeof(buffer), "6");
		DispatchKeyValue(g_SpriteModel[client], "endwidth", buffer);
		
		KvGetString(hKvTrails, "material", buffer, sizeof(buffer));
		DispatchKeyValue(g_SpriteModel[client], "spritename", buffer);
		DispatchKeyValue(g_SpriteModel[client], "renderamt", "255");
		
		KvGetString(hKvTrails, "color", buffer, sizeof(buffer));
		DispatchKeyValue(g_SpriteModel[client], "rendercolor", buffer);
		DispatchKeyValue(g_SpriteModel[client], "rendermode", "1");
		
		DispatchSpawn(g_SpriteModel[client]);
		
		KvGetVector(hKvTrails, "position", dest_vector);
		
		decl Float:or[3], Float:ang[3],
		Float:fForward[3],
		Float:fRight[3],
		Float:fUp[3];
		
		GetClientAbsOrigin(client, or);
		GetClientAbsAngles(client, ang);
		
		GetAngleVectors(ang, fForward, fRight, fUp);

		or[0] += fRight[0]*dest_vector[0] + fForward[0]*dest_vector[1] + fUp[0]*dest_vector[2];
		or[1] += fRight[1]*dest_vector[0] + fForward[1]*dest_vector[1] + fUp[1]*dest_vector[2];
		or[2] += fRight[2]*dest_vector[0] + fForward[2]*dest_vector[1] + fUp[2]*dest_vector[2];
		
		TeleportEntity(g_SpriteModel[client], or, NULL_VECTOR, NULL_VECTOR);
		
		SetVariantString("!activator");
		AcceptEntityInput(g_SpriteModel[client], "SetParent", client); 
		SetEntPropFloat(g_SpriteModel[client], Prop_Send, "m_flTextureRes", 0.05);
		SetEntPropEnt(g_SpriteModel[client], Prop_Send, "m_hOwnerEntity", client);
		
		if (hide)
		{
			SDKHook(g_SpriteModel[client], SDKHook_SetTransmit, Hook_TrailShouldHide);
		}
	}
	KvRewind(hKvTrails);
	
	return true;
}

public Action:Hook_TrailShouldHide(entity, client)
{
	if (toggleEffects && !ShowClientEffects(client))
	{
		return Plugin_Handled;
	}
	
	if (g_SpriteModel[client] == entity || iTeam[client] < 2)
	{
		return Plugin_Continue;
	}
	new owner = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	if (owner != -1 && iTeam[owner] != iTeam[client])
	{
		return Plugin_Handled;
	}
	return Plugin_Continue;
}

KillTrail(client)
{
	if (g_SpriteModel[client] > MaxClients && IsValidEdict(g_SpriteModel[client]))
	{
		AcceptEntityInput(g_SpriteModel[client], "kill");
	}
	
	g_SpriteModel[client] = -1;
}

stock File_GetExtension(const String:path[], String:buffer[], size)
{
	new extpos = FindCharInString(path, '.', true);
	
	if (extpos == -1)
	{
		buffer[0] = '\0';
		return;
	}

	strcopy(buffer, size, path[++extpos]);
}

stock File_ExtEqual(const String:path[], const String:ext[], bool:caseSensetive = false)
{
	decl String:buf[4];
	File_GetExtension(path, buf, sizeof(buf));
	return StrEqual(buf, ext, caseSensetive);
}